import { FixedStudioComponentProperty } from '@aws-amplify/codegen-ui';
import { TypeParameterDeclaration, TypeNode } from 'typescript';
export declare type PrimitiveLevelPropConfiguration<ConfigType> = {
    [componentType: string]: {
        [eventType: string]: ConfigType;
    };
};
export declare enum Primitive {
    Alert = "Alert",
    Badge = "Badge",
    Button = "Button",
    ButtonGroup = "ButtonGroup",
    Card = "Card",
    CheckboxField = "CheckboxField",
    Collection = "Collection",
    Divider = "Divider",
    Expander = "Expander",
    ExpanderItem = "ExpanderItem",
    Flex = "Flex",
    Grid = "Grid",
    Heading = "Heading",
    Icon = "Icon",
    Image = "Image",
    Link = "Link",
    Loader = "Loader",
    Menu = "Menu",
    MenuButton = "MenuButton",
    MenuItem = "MenuItem",
    Pagination = "Pagination",
    PasswordField = "PasswordField",
    PhoneNumberField = "PhoneNumberField",
    Placeholder = "Placeholder",
    Radio = "Radio",
    RadioGroupField = "RadioGroupField",
    Rating = "Rating",
    ScrollView = "ScrollView",
    SearchField = "SearchField",
    SelectField = "SelectField",
    SliderField = "SliderField",
    StepperField = "StepperField",
    SwitchField = "SwitchField",
    Table = "Table",
    TableBody = "TableBody",
    TableCell = "TableCell",
    TableFoot = "TableFoot",
    TableHead = "TableHead",
    TableRow = "TableRow",
    Tabs = "Tabs",
    TabItem = "TabItem",
    Text = "Text",
    TextAreaField = "TextAreaField",
    TextField = "TextField",
    ToggleButton = "ToggleButton",
    ToggleButtonGroup = "ToggleButtonGroup",
    View = "View",
    VisuallyHidden = "VisuallyHidden"
}
export declare const PrimitivesWithChangeEvent: Set<Primitive>;
export declare const PrimitiveChildrenPropMapping: Partial<Record<Primitive, string>>;
export declare const PrimitiveDefaultPropertyValue: PrimitiveLevelPropConfiguration<FixedStudioComponentProperty>;
export declare function isPrimitive(componentType: string): boolean;
export declare const PrimitiveTypeParameter: Partial<Record<Primitive, {
    declaration: () => TypeParameterDeclaration[] | undefined;
    reference: () => TypeNode[];
}>>;
